<?php

namespace Ardent\Undercurrent\Collector;

use Ardent\Undercurrent\Attribute\Route;

class RouteCollector
{
    public function __construct(
        private readonly string $path,
    )
    {
    }

    public function collect(): array
    {
        $routes = [];
        $classCollector = new ClassAttributeCollector($this->path);
        $classes = $classCollector->collect();

        foreach ($classes as $class) {
            $reflection = new \ReflectionClass($class);
            $reflectionMethods = $reflection->getMethods();

            foreach ($reflectionMethods as $reflectionMethod) {
                $attributes = $reflectionMethod->getAttributes(Route::class, \ReflectionAttribute::IS_INSTANCEOF);
                if (count($attributes) === 0) {
                    continue;
                }
                // todo: get the attribute, classname and route
            }
        }

        return $routes;
    }
}