<?php

namespace Ardent\Undercurrent\Container;

use Exception;

interface ContainerInterface
{
    public function add(
        string    $className,
        ?callable $definition = null,
        bool      $singleton = true
    ): self;

    /**
     * @template TClassName
     * @param class-string<TClassName> $className
     * @return TClassName
     * @throws ClassNotFoundException
     */
    public function get(string $className): object;

    public function call(string $className, string $methodName, array $parameters = []): mixed;
}